# mongoc_client_get_database_names_with_opts()

## Synopsis

    char **
    mongoc_client_get_database_names_with_opts (mongoc_client_t *client,
                                                const bson_t *opts,
                                                bson_error_t *error);

This function queries the MongoDB server for a list of known databases.

## Parameters

- `client`: A mongoc_client_t.
- `opts`: A `bson_t` containing additional options.
- `error`: An optional location for a bson_error_t or `NULL`.

`opts` may be NULL or a BSON document with additional command options:

- `sessionId`: First, construct a mongoc_client_session_t with mongoc_client_start_session(). You can begin a transaction with mongoc_client_session_start_transaction(), optionally with a mongoc_transaction_opt_t that overrides the options inherited from `client`, and use mongoc_client_session_append() to add the session to `opts`. See the example code for mongoc_client_session_t.
- `serverId`: To target a specific server, include an int32 “serverId” field. Obtain the id by calling mongoc_client_select_server(), then mongoc_server_description_id() on its return value.

This function is considered a retryable read operation. Upon a transient error (a network error, errors due to replica set failover, etc.) the operation is safely retried once. If `retryreads` is false in the URI (see mongoc_uri_t) the retry behavior does not apply.

## Errors

Errors are propagated via the `error` parameter.

## Returns

A `NULL` terminated vector of `NULL-byte` terminated strings. The result should be freed with `bson_strfreev()`.

`NULL` is returned upon failure and `error` is set.

## Examples

    {
       bson_error_t error;
       char **strv;
       unsigned i;

       if ((strv = mongoc_client_get_database_names_with_opts (client, NULL, &error))) {
          for (i = 0; strv[i]; i++)
             printf ("%s\n", strv[i]);
          bson_strfreev (strv);
       } else {
          fprintf (stderr, "Command failed: %s\n", error.message);
       }
    }